AchievementFrenzyWaitingRoom = class(Turbine.UI.Control)
function AchievementFrenzyWaitingRoom:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Swift Strike"] = true,
        ["Wild Attack"] = true,
        ["Fear Nothing!"] = true,
        ["Devastating Strike"] = true,
        ["Rend"] = true,
        ["Controlled Burn"] = true,
        ["Champion's Duel"] = true,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Frenzy Waiting Room")
    end

    Turbine.Shell.AddCommand("hardcorefrenzywaitingroom", self.command)

    ChatOutput("Use the command /hardcorefrenzywaitingroom to see a list of affected skills")


    self.handler = handler

    self:SetCallbacks()
end

function AchievementFrenzyWaitingRoom:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then

            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Frenzy Waiting Room", "Usage of a fervour generating skill", 0x410000E6)
            end))
        end
    end
end

function AchievementFrenzyWaitingRoom:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementFrenzyWaitingRoom:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementFrenzyWaitingRoom:GetHint()
    ChatOutput("<rgb=#005500>Only use fervour spenders and the only way to generate to generate fervour is battle frenzy.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end